#include "defines.h"
#include "kozos.h"
#include "netdrv.h"
#include "tcp.h"
#include "lib.h"

static char header[] =
"HTTP/1.0 200 OK\r\n"
/*"Date: Sat, 23 Oct 2010 12:00:00 GMT\r\n"*/
"Server: KOZOS-httpd/1.0\r\n"
"Content-Type: text/html\r\n"
"Content-Length: #####\r\n"
"\r\n";

static char top_document[] =
"<html>\n"
"<head>\n"
"<title>This is KOZOS!</title>\n"
"<meta http-equiv=\"Content-Type\" content=\"text/html; charset=EUC-JP\">\n"
"</head>\n"
"<body bgcolor=\"yellow\" text=\"blue\" link=\"red\" vlink=\"black\">\n"
"<center>\n"
"<h1>HTTP server on KOZOS (#####)</h1>\n"
"<p><a href=\"about.html\">KOZOSȤϡ</a>\n"
"<p><a href=\"kozos.html\">KOZOSθ</a>\n"
"<p><a href=\"makeos.html\">ȹߣϣӤäƤߤޤ󤫡</a>\n"
"</center>\n"
"</body>\n"
"</html>\n";

static char about_document[] =
"<html>\n"
"<head>\n"
"<title>KOZOSȤϡ</title>\n"
"<meta http-equiv=\"Content-Type\" content=\"text/html; charset=EUC-JP\">\n"
"</head>\n"
"<body bgcolor=\"brown\" text=\"white\" link=\"yellow\" vlink=\"black\">\n"
"<center><h1>KOZOSȤϡ(#####)</h1></center>\n"
"<p>KOZOSϺ湰μƤ롤ؽȹOSǤ˽ŻҤH8/3069FޥܡɤưȹOSμưʤɤγؽǤޤ\n"
"<p>ʲǡĿͤǤγؽѤ˸Ƥޤ\n"
"<ul>\n"
"<li>ȹOS١̤1800٤ȾʤؼԤǤɲǽ\n"
"<li>ưޥܡɤ4000٤Ȱ²ʤΤǡĿͤǤǽޤ½ʤɤѤˤ⡤̤ҤȤˤҤȤĶƲǽʲʡ\n"
"<li>ȤΩƺѤߥܡɤΤȾդʤɤפǡäγؽǽ\n"
"<li>ꥢͳǥեåROM񤭴ǽʤᡤICEROM饤ʤɤס\n"
"<li>CPU(H8)ܡɤΤܸλ˭١\n"
"<li>֡ȥޤ᤿ե륹åOSǤ뤿κǽ餫γؽǽ\n"
"<li>ȯĶGNUĶǤ뤿CPUΥѥ˰¸ʤĤ֤θؽǽ\n"
"<li>ҡ12ƥåפǺ ȹߣϣӼפ˾ܺ٤ʲ⤢ꡥ\n"
"<li>ץ󥽡饤󥹤Τ¤ͳ\n"
"</ul>\n"
"<p>ȹOSѤ½ʤɹԤȤ⡤ȹOS¤ưΤΤ򤹤롤ʬǲ¤ä򿼤Ȥäؽ˸ƤޤּŪ˻ȤOSפǤʤ¤򤷡¤굡ǽɲäꤷƤäͷ֤OSפȤ򤯤\n"
"<hr>\n"
"<ul>\n"
"<li><a href=\"index.html\">ȥåץڡ</a>\n"
"</ul>\n"
"<address>\n"
"᡼<a href=\"mailto:hsakai@saturn.dti.ne.jp\">hsakai@saturn.dti.ne.jp</a>ޤ\n"
"</address>\n"
"</body>\n"
"</html>\n";

static char kozos_document[] =
"<html>\n"
"<head>\n"
"<title>KOZOSθ</title>\n"
"<meta http-equiv=\"Content-Type\" content=\"text/html; charset=EUC-JP\">\n"
"</head>\n"
"<body bgcolor=\"brown\" text=\"white\" link=\"yellow\" vlink=\"black\">\n"
"<center><h1>KOZOSθ(#####)</h1></center>\n"
"<p>KOZOSKOZOSץȤˤ곫ȯʤƤޤ(ޤͤǤäƤΤǤ)\n"
"<p>ʲǤ˼¸Ƥޤ\n"
"<ul>\n"
"<li>ϣӤȤƤκ¤εǽĥߥ˥ޥʥͥ\n"
"<li>ȼΥ֡ȥ\n"
"<li>ޥưI/O(ߴ)̿\n"
"<li>H8SH2PowerPCʤɤǤư\n"
"<li>ꥢͳǤΥޥɱ\n"
"<li>DRAMб\n"
"<li>ޥӥ\n"
"<li>ethernetTCP/IPˤ̿ǽ\n"
"<li>ʰweb\n"
"<li>ߥ졼Ǥư\n"
"<li>ҡ12ƥåפǺ ȹߣϣӼפν\n"
"</ul>\n"
"<p>ʲϺʤƤͽκȰǤ\n"
"<ul>\n"
"<li>ǥХåб\n"
"<li>եžǽ\n"
"<li>ץꥱưŪ¹\n"
"<li>ޥե\n"
"<li>ROM\n"
"<li>ꥢ륿ಽ\n"
"<li>ͥ˥ǥХåǽ\n"
"<li>SH2ؤб\n"
"<li>12ƥåפǺ ȹߣϣӼפ³Ԥ\n"
"</ul>\n"
"<p>ꤿȤϤäѤ\n"
"<hr>\n"
"<ul>\n"
"<li><a href=\"index.html\">ȥåץڡ</a>\n"
"</ul>\n"
"<address>\n"
"᡼<a href=\"mailto:hsakai@saturn.dti.ne.jp\">hsakai@saturn.dti.ne.jp</a>ޤ\n"
"</address>\n"
"</body>\n"
"</html>\n";

static char makeos_document[] =
"<html>\n"
"<head>\n"
"<title>ȹOSäƤߤޤ󤫡</title>\n"
"<meta http-equiv=\"Content-Type\" content=\"text/html; charset=EUC-JP\">\n"
"</head>\n"
"<body bgcolor=\"brown\" text=\"white\" link=\"yellow\" vlink=\"black\">\n"
"<center><h1>ȹOSäƤߤޤ󤫡(#####)</h1></center>\n"
"<p>ȹߡסȹߥƥס֥٥ǥåɡפȤդ̤Ǥ褯ʹ褦ˤʤäƤޤȹʬ˶̣Τͤ߿Ϥʤʤ¿ȻפΤǤƱˡ֤ȤäĤˤס֤褯狼ʤפȤäۤʹȤޤʤ֤ȤäĤˤפΤǤ礦\n"
"<p>ȹߥƥٶ򤷤ȻפäȤФüᤤΤŬʥܡɥԥ塼ꤷơLinuxʤITRONʤȤäOS򥤥󥹥ȡ뤷ơʬǤäƤߤ뤳ȤǤˤOSɤư򤷤ꡤOS˼Ʋ¤ꤷƤХХåǤ礦\n"
"<p>LinuxΥ̤OS鿴ԤϤɤ߲򤤤ƤΤϡʺɬפǤ礦ưˤɤȤƤ⡤줬ɤʤΤȽ̤ǰϫǤITRONμǤTOPPERSHOSˤĤƤƱͤǤ礦¿CPUб¿ǽΤ˳ز٤⤯Ƥä̤ʤΤǼOSȤƤѤȻפΤǤΤ˴ؿƤӽФޥʤɤγؤɤߤˤʤäƤ뤳Ȥϻ¤ǡOS鿴ԤϤǥѥäɤ߲򤱤褦ʤΤǤϤʤʤäƤޤ\n"
"<p>ǤϤäȼڤOS١ˤƳؽФΤǤ礦ˤϥץ󥽡ǼڤȹOS¿ޤǤ⤦ҤȤˤʤΤϡOSưܡɤǤȼOS¿CPUɾܡɤʤɤǤưˤƤޤɾܡɤOSܿȤǸȺŬʤΤǤĿѤȤǸȡ̿Ūʷ٤ޤϤʤȤäƤ֤⤤פΤǤߡߤΤǤŪ̳Τ˸漼ҤǹʤСɤȤȤϤʤΤǤ礦OSٶΤ˸Ŀͤǹˤϡäȵڤˤ㤨ʤۤǤ\n"
"<p>ȹOSνҤ͡ޤ鿴ԤĿͥ٥ǳؽǤȤȤ򿿷˹ͤƽ񤫤줿Τ˾ʤפޤоݤȤOSͭǿߤ⤷ꡤͭγȯĶѤƤꡤüʥܡɤоݤˤƤΤ⤢ޤǤϸ¤ȤơĿͥ٥ǻޤ󡥤ۤȤ˺٤ȤǤΤ꤬ȹߤ񤷤פȻפƤͳΤ褦˻פޤޤνҤOSֻȤפΤΤǤäơOSֺפʤƤΤϤۤȤɤޤ\n"
"<p>⹻Ǥ⤪ϰϤ㤨褦ʶۤΥܡɤươ鿴ԤǤ⽽ʬɲǤƵڤ˲¤Ǥ褦ñʥɹǡӥɤüʥץȼ¹ԤʤɤɬפȤȯĶ̵ǤơδĶˤФʤĤ֤ؽǤơץ󥽡Ǥ뤳ȡĿͤγؽѤˤϡΤ褦ʾ郎ɬܤǤΤ褦OSγؽѤΥץˤʤȹOS̵ΤǤƤ伫ȤΤߤäΤǤ\n"
"<p>OSȤ߷פ줿OSǤϡξȤԲǽǤʤʤС߷׻ۤᤫۤʤäƤ뤫ǤᤫؽŪȤ߷פ줿ȹOSɬפʤΤǤ\n"
"<p>KOZOSϤΤ褦ʹͤǺƤޤPCСȤ5000ߤ餤ǤҤȤȤϤäơ鿴ԤǤɤߤ륳̡ïǤñ˲¤ǤơѥäȤȤǤ롥ʥݥꥷǺƤޤ󥪡ץ󥽡ե꡼եȤǤ\n"
"<p>H8ѤKOZOSǤϥ֡ȥ١OSΤ٤ǤʤСʬǤɤߤ褦ʵƤޤ󤫡 äȴĥмʬˤΤǤϤʤȤˤʤΤǤϤʤǤ礦ܡɤ4000߼塤ʥܡɤʤΤȾդ餺ꥢͳǥեåROMν񤭴ǽʤΤROM饤פROMƤƤ¿ΤïǤǽǤȯĶFreeBSDGNU/LinuxCygwinΤ줫GNUȯĶꤷƤΤǱϰϤ⹭塹ˤĤ֤ؽǤޤ񻺥ܡɡCPUʤΤܸ⽼¡ۤȤïǤޤ\n"
"<p>εȹOSٶƤߤΤϤɤǤ礦ʤǡOS򼫺ƤߤΤϤɤǤ礦OSٶˤʤ뤷ȤƤ򤤤Ǥ衪\n"
"<hr>\n"
"<ul>\n"
"<li><a href=\"index.html\">ȥåץڡ</a>\n"
"</ul>\n"
"<address>\n"
"᡼<a href=\"mailto:hsakai@saturn.dti.ne.jp\">hsakai@saturn.dti.ne.jp</a>ޤ\n"
"</address>\n"
"</body>\n"
"</html>\n";

static char unknown_document[] =
"<html>\n"
"<head>\n"
"<title>Unknown Request</title>\n"
"<meta http-equiv=\"Content-Type\" content=\"text/html; charset=EUC-JP\">\n"
"</head>\n"
"<body bgcolor=\"yellow\" text=\"blue\" link=\"red\" vlink=\"black\">\n"
"<center>\n"
"<h1>Unknown Request (#####)</h1>\n"
"<p><a href=\"index.html\">ȥåץڡ</a>\n"
"</center>\n"
"</body>\n"
"</html>\n";

static struct documents {
  char *counterp;
  char *filename;
  char *document;
} documents[] = {
  { NULL, "/index.html", top_document },
  { NULL, "/about.html", about_document },
  { NULL, "/kozos.html", kozos_document },
  { NULL, "/makeos.html", makeos_document },
  { NULL, NULL, unknown_document }
};

static void send_accept()
{
  struct netbuf *buf;
  buf = kz_kmalloc(sizeof(*buf));
  buf->cmd = TCP_CMD_ACCEPT;
  buf->option.tcp.accept.id = MSGBOX_ID_HTTPD;
  buf->option.tcp.accept.port = 80;
  kz_send(MSGBOX_ID_TCPPROC, 0, (char *)buf);
}

static void send_close(int number)
{
  struct netbuf *buf;
  buf = kz_kmalloc(sizeof(*buf));
  buf->cmd = TCP_CMD_CLOSE;
  buf->option.tcp.close.number = number;
  kz_send(MSGBOX_ID_TCPPROC, 0, (char *)buf);
}

static void send_write(int number, int size, char *data)
{
  struct netbuf *buf;
  buf = kz_kmalloc(DEFAULT_NETBUF_SIZE);
  memset(buf, 0, DEFAULT_NETBUF_SIZE);
  buf->cmd = TCP_CMD_SEND;
  buf->top = buf->data;
  buf->size = size;
  buf->option.tcp.send.number = number;
  memcpy(buf->top, data, size);
  kz_send(MSGBOX_ID_TCPPROC, 0, (char *)buf);
}

static void send_string(int number, char *str)
{
  int len, size;
  len = strlen(str);
  while (len > 0) {
    size = (len > 512) ? 512 : len;
    send_write(number, size, str);
    len -= size;
    str += size;
  }
}

static char *val2str(int value)
{
  static char str[11];
  int i;
  char *top;

  memset(str, '0', sizeof(str));
  str[10] = '\0';
  top = &str[9];

  for (; value > 0; value--) {
    str[9]++;
    for (i = 10 - 1; i >= 0; i--) {
      if ((str[i] > '9') && (i > 0)) {
        str[i] = '0';
        str[i - 1]++;
      }
      if ((&str[i] < top) && (str[i] > '0'))
        top = &str[i];
    }
  }

  return top;
}

static int parse(int number, char *str)
{
  static int count = 0;
  static char *length_p = NULL;
  char *filename, *p;
  struct documents *docs;

  if (strncmp(str, "GET", 3))
    return 0;

  for (p = str + 3; *p == ' '; p++)
    ;
  filename = p;
  p = strchr(p, ' ');
  *p = '\0';

  if (!strcmp(filename, "/"))
    filename = "/index.html";

  for (docs = documents; docs->filename; docs++)
    if (!strcmp(filename, docs->filename))
      break;

  if (!docs->counterp) docs->counterp = strchr(docs->document, '#');
  memset(docs->counterp, ' ', 5);
  p = val2str(count);
  memcpy(docs->counterp, p, strlen(p));
  count++;

  if (!length_p) length_p = strchr(header, '#');
  memset(length_p, ' ', 5);
  p = val2str(strlen(docs->document));
  memcpy(length_p, p, strlen(p));

  send_string(number, header);
  send_string(number, docs->document);
  return 1;
}

int httpd_main(int argc, char *argv[])
{
  static char *p = NULL;
  char *r;
  static char *buffer = NULL;
  static int number = 0;
  int ret;
  struct netbuf *buf;
  static int initialized = 0;

  if (!initialized) {
    send_accept();

    buffer = kz_kmalloc(DEFAULT_NETBUF_SIZE);

    initialized++;
  }

  if (kz_recv(MSGBOX_ID_HTTPD, NULL, (void *)&buf) != -1) {
    switch (buf->cmd) {
    case TCP_CMD_ESTAB:
      number = buf->option.tcp.establish.number;
      p = buffer;
      break;

    case TCP_CMD_CLOSE:
      number = 0;
      send_accept();
      break;

    case TCP_CMD_RECV:
      memcpy(p, buf->top, buf->size);
      p += buf->size;
      *p = '\0';

      r = strchr(buffer, '\n');
      if (r) {
	*r = '\0';
	r++;
	ret = parse(number, buffer);
	memmove(buffer, r, p - r + 1);
	p -= (r - buffer);
	if (ret) send_close(number);
      }
      break;
    }

    kz_kmfree(buf);
  }

  return 0;
}
